package org.bdware.mockjava;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;

public abstract class JsonVisitor {
    JsonElement result;

    public JsonElement get() {
        return result;
    }

    public JsonVisitor visit(JsonElement ele) {
        if (null == ele) {
            return null;
        }
        if (ele.isJsonArray()) {
            return visitJsonArray((JsonArray) ele);
        } else if (ele.isJsonObject()) {
            return visitObject(ele.getAsJsonObject());
        } else {
            JsonPrimitive primitive = ele.getAsJsonPrimitive();
            return visitPrimitive(primitive);
        }
    }

    public JsonVisitor visitObject(JsonObject jsonObject) {
        JsonObject jo = new JsonObject();
        for (String key : jsonObject.keySet()) {
            JsonElement origin = jsonObject.get(key);
            visit(origin);
            JsonElement je = get();
            if (origin.isJsonArray()) {
                key += "|" + Math.min(((JsonArray) origin).size(), 20);
            }
            jo.add(key, je);
        }
        result = jo;
        return this;
    }

    public abstract JsonVisitor visitJsonArray(JsonArray ele);

    public abstract JsonVisitor visitPrimitive(JsonPrimitive primitive);

}
