package org.bdware.mockjava;

import com.google.gson.JsonArray;
import com.google.gson.JsonPrimitive;

public class MockSchemaParser extends JsonVisitor {
    public static MockSchemaParser instance = new MockSchemaParser();

    @Override
    public JsonVisitor visitJsonArray(JsonArray array) {
        JsonArray ret = new JsonArray();
        if (array.size() > 0) {
            visit(array.get(0));
            ret.add(result);
        }
        result = ret;
        return this;
    }

    @Override
    public JsonVisitor visitPrimitive(JsonPrimitive primitive) {
        if (primitive.isBoolean()) {
            result = new JsonPrimitive("@boolean");
        } else if (primitive.isNumber()) {
            result = new JsonPrimitive("@integer");
        } else {
            result = new JsonPrimitive("@string");
        }
        return this;
    }
}